package gorm_helper

import (
	"fmt"
	"git.icechen.cn/monorepo/backend/app/brahma/api/murder/internal/config"
	"git.icechen.cn/monorepo/backend/app/brahma/api/murder/internal/error_process"
	"github.com/gofiber/fiber/v2"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
)

type MysqlMapType map[string]*gorm.DB

var mysqlMap = make(MysqlMapType, 0)

func GormMap(dsnPre string) error {
	dsn := fmt.Sprintf("%v/%v?charset=utf8mb4&parseTime=True&loc=Local", dsnPre, config.TestDB)
	db, err := gorm.Open(mysql.Open(dsn), &gorm.Config{})
	if err != nil {
		return err
	}
	err = db.Use(&TracePlugin{})
	if err != nil {
		return err
	}
	mysqlMap[config.TestDB] = db
	return nil
}

func GetMap() MysqlMapType {
	return mysqlMap
}

func GetContextDB(ctx *fiber.Ctx, name ...string) (*gorm.DB, error) {
	//自定义插件接收ctx 里面的 自定义context，打印日志
	_ctx := ctx.UserContext()
	db := GetMap()
	dbName := config.TestDB
	if len(name) != 0 {
		dbName = name[0]
	}
	if v, ok := db[dbName]; ok {
		return v.WithContext(_ctx), nil
	}
	return nil, error_process.DbNotFoundErr(dbName)
}
