package lark

import (
	"context"
	"fmt"
	"google.golang.org/grpc/keepalive"
	"log"
	"net"
	"time"

	"git.icechen.cn/monorepo/backend/pkg/proto/zeus/lark"
	"github.com/jinzhu/copier"
	"google.golang.org/grpc"
	"google.golang.org/grpc/reflection"
)

func RpcServer() {
	lis, err := net.Listen("tcp", ":3000")
	if err != nil {
		log.Fatalf("failed to listen: %v", err)
	}

	s := grpc.NewServer(grpc.KeepaliveParams(keepalive.ServerParameters{
		MaxConnectionIdle: 5 * time.Minute,
	}))
	lark.RegisterUserServer(s, &Server{})

	reflection.Register(s)

	fmt.Println("lark server run in :3000")
	if err := s.Serve(lis); err != nil {
		log.Fatalf("failed to serve: %v", err)
	}
}

type Server struct{}

func (s Server) Login(ctx context.Context, in *lark.LoginRequest) (*lark.LoginResponse, error) {
	userInfo, err := NewLark().Auth(in.Code)
	if err != nil {
		return nil, err
	}

	resp := new(lark.LoginResponse)
	err = copier.Copy(resp, userInfo)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
